opal/mca/base/mca_base_param.h File Reference.TH "opal/mca/base/mca_base_param.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/mca/base/mca_base_param.h \- This file presents the MCA parameter interface. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'opal/class/opal_value_array.h'\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br
\fC#include 'opal/class/opal_hash_table.h'\fP
.br
\fC#include 'opal/mca/mca.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_base_param_info_t\fP \fBmca_base_param_info_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBmca_base_param_type_t\fP { \fBMCA_BASE_PARAM_TYPE_INT\fP, \fBMCA_BASE_PARAM_TYPE_STRING\fP, \fBMCA_BASE_PARAM_TYPE_MAX\fP }"
.br
.RI "\fIThe types of MCA parameters. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (\fBmca_base_param_info_t\fP)"
.br
.RI "\fIMake a real object for the info. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_init\fP (void)"
.br
.RI "\fIInitialize the MCA parameter system. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_reg_int\fP (const \fBmca_base_component_t\fP *component, const char *param_name, const char *help_msg, bool internal, bool read_only, int default_value, int *current_value)"
.br
.RI "\fIRegister an integer MCA parameter. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_reg_int_name\fP (const char *type, const char *param_name, const char *help_msg, bool internal, bool read_only, int default_value, int *current_value)"
.br
.RI "\fIRegister an integer MCA parameter that is not associated with a component. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_reg_string\fP (const \fBmca_base_component_t\fP *component, const char *param_name, const char *help_msg, bool internal, bool read_only, const char *default_value, char **current_value)"
.br
.RI "\fIRegister a string MCA parameter. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_reg_string_name\fP (const char *type, const char *param_name, const char *help_msg, bool internal, bool read_only, const char *default_value, char **current_value)"
.br
.RI "\fIRegister a string MCA parameter that is not associated with a component. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_kv_associate\fP (int index, int keyval)"
.br
.RI "\fIAssociate a communicator/datatype/window keyval with an MCA parameter. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_lookup_int\fP (int index, int *value)"
.br
.RI "\fILook up an integer MCA parameter. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_kv_lookup_int\fP (int index, struct opal_hash_table_t *attrs, int *value)"
.br
.RI "\fILook up an integer MCA parameter, to include looking in attributes. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_lookup_string\fP (int index, char **value)"
.br
.RI "\fILook up a string MCA parameter. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_kv_lookup_string\fP (int index, struct opal_hash_table_t *attrs, char **value)"
.br
.RI "\fILook up a string MCA parameter, to include looking in attributes. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_set_int\fP (int index, int value)"
.br
.RI "\fISets an 'override' value for an integer MCA parameter. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_set_string\fP (int index, char *value)"
.br
.RI "\fISets an 'override' value for an string MCA parameter. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_unset\fP (int index)"
.br
.RI "\fIUnset a parameter that was previously set by \fBmca_base_param_set_int()\fP or \fBmca_base_param_set_string()\fP. \fP"
.ti -1c
.RI "OMPI_DECLSPEC char * \fBmca_base_param_env_var\fP (const char *param_name)"
.br
.RI "\fIGet the string name corresponding to the MCA parameter value in the environment. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_find\fP (const char *type, const char *component, const char *param)"
.br
.RI "\fIFind the index for an MCA parameter based on its names. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_set_internal\fP (int index, bool internal)"
.br
.RI "\fISet the 'internal' flag on an MCA parameter to true or false. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_dump\fP (\fBopal_list_t\fP **info, bool internal)"
.br
.RI "\fIObtain a list of all the MCA parameters currently defined as well as their types. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_build_env\fP (char ***env, int *num_env, bool internal)"
.br
.RI "\fIObtain a list of all the MCA parameters currently defined as well as their types. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_dump_release\fP (\fBopal_list_t\fP *info)"
.br
.RI "\fIRelease the memory associated with the info list returned from \fBmca_base_param_dump()\fP. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_finalize\fP (void)"
.br
.RI "\fIShut down the MCA parameter system (normally only invoked by the MCA framework itself). \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_register_int\fP (const char *type_name, const char *component_name, const char *param_name, const char *mca_param_name, int default_value)"
.br
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_base_param_register_string\fP (const char *type_name, const char *component_name, const char *param_name, const char *mca_param_name, const char *default_value)"
.br
.ti -1c
.RI "OMPI_DECLSPEC char * \fBmca_base_param_environ_variable\fP (const char *type, const char *comp, const char *param)"
.br
.in -1c
.SH "Detailed Description"
.PP 
This file presents the MCA parameter interface. 

Note that there are two scopes for MCA parameters: 'normal' and attributes. Specifically, all MCA parameters are 'normal' -- some are special and may also be found on attributes on communicators, datatypes, or windows.
.PP
In general, these functions are intended to be used as follows:
.PP
.IP "\(bu" 2
Creating MCA parameters
.PP
.IP "1." 4
Register a parameter, get an index back
.IP "2." 4
Optionally associate that index with an attribute keyval
.PP
.IP "\(bu" 2
Using MCA parameters
.PP
.IP "1." 4
Lookup a 'normal' parameter value on a specific index, or
.IP "2." 4
Lookup an attribute parameter on a specific index and communicator / datatype / window.
.PP
.PP
MCA parameters can be defined in multiple different places. As such, parameters are \fIresolved\fP to find their value. The order of resolution is as follows:
.PP
.IP "\(bu" 2
An 'override' location that is only available to be set via the mca_base_param API.
.IP "\(bu" 2
If the parameter has an MPI attribute keyval associated with it, see if there is a value assigned that can be used.
.IP "\(bu" 2
Look for an environment variable corresponding to the MCA parameter.
.IP "\(bu" 2
See if a file contains the MCA parameter (MCA parameter files are read only once -- when the first time any mca_param_t function is invoked).
.IP "\(bu" 2
If nothing else was found, use the parameter's default value.
.PP
.PP
Note that there is a second header file (\fBmca_base_param_internal.h\fP) that contains several internal type delcarations for the parameter system. The internal file is only used within the parameter system itself; it should not be required by any other Open MPI entities.
.SH "Enumeration Type Documentation"
.PP 
.SS "enum \fBmca_base_param_type_t\fP"
.PP
The types of MCA parameters. 
.PP
\fBEnumeration values: \fP
.in +1c
.TP
\fB\fIMCA_BASE_PARAM_TYPE_INT \fP\fP
The parameter is of type integer. 
.TP
\fB\fIMCA_BASE_PARAM_TYPE_STRING \fP\fP
The parameter is of type string. 
.TP
\fB\fIMCA_BASE_PARAM_TYPE_MAX \fP\fP
Maximum parameter type. 
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int mca_base_param_build_env (char *** env, int * num_env, bool internal)"
.PP
Obtain a list of all the MCA parameters currently defined as well as their types. 
.PP
\fBParameters:\fP
.RS 4
\fIenv\fP [out] A pointer to an argv-style array of key=value strings, suitable for use in an environment 
.br
\fInum_env\fP [out] A pointer to an int, containing the length of the env array (not including the final NULL entry). 
.br
\fIinternal\fP [in] Whether to include the internal parameters or not.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP Upon success. 
.br
\fIOMPI_ERROR\fP Upon failure.
.RE
.PP
This function is similar to \fBmca_base_param_dump()\fP except that its output is in terms of an argv-style array of key=value strings, suitable for using in an environment. 
.SS "OMPI_DECLSPEC int mca_base_param_dump (\fBopal_list_t\fP ** info, bool internal)"
.PP
Obtain a list of all the MCA parameters currently defined as well as their types. 
.PP
\fBParameters:\fP
.RS 4
\fIinfo\fP [out] An opal_list_t of \fBmca_base_param_info_t\fP instances. 
.br
\fIinternal\fP [in] Whether to include the internal parameters or not.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP Upon success. 
.br
\fIOMPI_ERROR\fP Upon failure.
.RE
.PP
This function is used to obtain a list of all the currently registered MCA parameters along with their associated types (currently: string or integer). The results from this function can be used to repeatedly invoke \fBmca_base_param_lookup_int()\fP and/or \fBmca_base_param_lookup_string()\fP to obtain a comprehensive list of all MCA parameters and their current values.
.PP
Releasing the list, and all the items in the list, is a relatively complicated process. Use the companion function \fBmca_base_param_dump_release()\fP when finished with the returned info list to release all associated memory. 
.SS "OMPI_DECLSPEC int mca_base_param_dump_release (\fBopal_list_t\fP * info)"
.PP
Release the memory associated with the info list returned from \fBmca_base_param_dump()\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIinfo\fP [in/out] An opal_list_t previously returned from \fBmca_base_param_dump()\fP.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP Upon success. 
.br
\fIOMPI_ERROR\fP Upon failure.
.RE
.PP
This function is intended to be used to free the info list returned from \fBmca_base_param_dump()\fP. There are a bunch of strings and other associated memory in the list making it cumbersome for the caller to free it all properly. Hence, once the caller is finished with the info list, invoke this function and all memory associated with the list will be freed. 
.SS "OMPI_DECLSPEC char* mca_base_param_env_var (const char * param_name)"
.PP
Get the string name corresponding to the MCA parameter value in the environment. 
.PP
\fBParameters:\fP
.RS 4
\fIparam_name\fP Name of the type containing the parameter.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIstring\fP A string suitable for setenv() or appending to an environ-style string array. 
.br
\fINULL\fP Upon failure.
.RE
.PP
The string that is returned is owned by the caller; if appropriate, it must be eventually freed by the caller. 
.SS "OMPI_DECLSPEC char* mca_base_param_environ_variable (const char * type, const char * comp, const char * param)"
.PP
\fBDeprecated\fP
.RS 4
.RE
.PP
Get the string name corresponding to the MCA parameter value in the environment (deprecated).
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Name of the type containing the parameter. 
.br
\fIcomp\fP Name of the component containing the parameter. 
.br
\fIparam\fP Name of the parameter.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIstring\fP A string suitable for setenv() or appending to an environ-style string array. 
.br
\fINULL\fP Upon failure.
.RE
.PP
This function is deprecated. Use \fBmca_base_param_env_var()\fP instead.
.PP
The string that is returned is owned by the caller; if appropriate, it must be eventually freed by the caller. 
.SS "OMPI_DECLSPEC int mca_base_param_finalize (void)"
.PP
Shut down the MCA parameter system (normally only invoked by the MCA framework itself). 
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS This function never fails.
.RE
.PP
This function shuts down the MCA parameter repository and frees all associated memory. No other mca_base_param*() functions can be invoked after this function.
.PP
This function is normally only invoked by the MCA framework itself when the process is shutting down (e.g., during MPI_FINALIZE). It is only documented here for completeness. 
.SS "OMPI_DECLSPEC int mca_base_param_find (const char * type, const char * component, const char * param)"
.PP
Find the index for an MCA parameter based on its names. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Name of the type containing the parameter. 
.br
\fIcomponent\fP Name of the component containing the parameter. 
.br
\fIparam\fP Name of the parameter.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP If the parameter was not found. 
.br
\fIindex\fP If the parameter was found.
.RE
.PP
It is not always convenient to widely propagate a parameter's index value, or it may be necessary to look up the parameter from a different component -- where it is not possible to have the return value from \fBmca_base_param_register_int()\fP or \fBmca_base_param_register_string()\fP. This function can be used to look up the index of any registered parameter. The returned index can be used with \fBmca_base_param_lookup_int()\fP and \fBmca_base_param_lookup_string()\fP. 
.SS "OMPI_DECLSPEC int mca_base_param_init (void)"
.PP
Initialize the MCA parameter system. 
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP This function initalizes the MCA parameter system. It is invoked internally (by mca_base_open()) and is only documented here for completeness. 
.RE
.PP

.SS "OMPI_DECLSPEC int mca_base_param_kv_associate (int index, int keyval)"
.PP
Associate a communicator/datatype/window keyval with an MCA parameter. 
.PP
\fBParameters:\fP
.RS 4
\fIindex\fP The index of the parameter to use. 
.br
\fIkeyval\fP The keyval to associate it with.
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS Upon success. 
.PP
OMPI_ERROR If the index value is invalid.
.RE
.PP
For an index value that was previously returned by \fBmca_base_param_register_int()\fP or \fBmca_base_param_register_string()\fP, the corresponding MCA parameter can be associated with a communicator, datatype, or window attribute keyval.
.PP
After using this function, you can use any of the four lookup functions (\fBmca_base_param_lookup_int()\fP, \fBmca_base_param_lookup_string()\fP, \fBmca_base_param_kv_lookup_int()\fP, and \fBmca_base_param_kv_lookup_string()\fP), but only the 'kv' versions will cross reference and attempt to find parameter values on attributes. 
.SS "OMPI_DECLSPEC int mca_base_param_kv_lookup_int (int index, struct opal_hash_table_t * attrs, int * value)"
.PP
Look up an integer MCA parameter, to include looking in attributes. 
.PP
\fBParameters:\fP
.RS 4
\fIindex\fP Index previous returned from \fBmca_base_param_register_int()\fP. 
.br
\fIattrs\fP Object containing attributes to be searched. 
.br
\fIvalue\fP Pointer to int where the parameter value will be stored.
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_ERROR Upon failure. The contents of value are undefined. 
.PP
OMPI_SUCCESS Upon success. value will be filled with the parameter's current value.
.RE
.PP
This function is identical to \fBmca_base_param_lookup_int()\fP except that it looks in attributes \fIfirst\fP to find the parameter value. The function \fBmca_base_param_kv_associate()\fP must have been called first to associate a keyval with the index. 
.SS "OMPI_DECLSPEC int mca_base_param_kv_lookup_string (int index, struct opal_hash_table_t * attrs, char ** value)"
.PP
Look up a string MCA parameter, to include looking in attributes. 
.PP
\fBParameters:\fP
.RS 4
\fIindex\fP [in] Index previous returned from \fBmca_base_param_register_string()\fP. 
.br
\fIattrs\fP [in] Object containing attributes to be searched. 
.br
\fIvalue\fP [out] Pointer to (char *) where the parameter value will be stored.
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_ERROR Upon failure. The contents of value are undefined. 
.PP
OMPI_SUCCESS Upon success. value will be filled with the parameter's current value.
.RE
.PP
This function is identical to \fBmca_base_param_lookup_string()\fP except that it looks in attributes \fIfirst\fP to find the parameter value. The function \fBmca_base_param_kv_associate()\fP must have been called first to associate a keyval with the index. 
.SS "OMPI_DECLSPEC int mca_base_param_lookup_int (int index, int * value)"
.PP
Look up an integer MCA parameter. 
.PP
\fBParameters:\fP
.RS 4
\fIindex\fP Index previous returned from \fBmca_base_param_register_int()\fP. 
.br
\fIvalue\fP Pointer to int where the parameter value will be stored.
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_ERROR Upon failure. The contents of value are undefined. 
.PP
OMPI_SUCCESS Upon success. value will be filled with the parameter's current value.
.RE
.PP
The value of a specific MCA parameter can be looked up using the return value from \fBmca_base_param_register_int()\fP. 
.SS "OMPI_DECLSPEC int mca_base_param_lookup_string (int index, char ** value)"
.PP
Look up a string MCA parameter. 
.PP
\fBParameters:\fP
.RS 4
\fIindex\fP Index previous returned from \fBmca_base_param_register_string()\fP. 
.br
\fIvalue\fP Pointer to (char *) where the parameter value will be stored.
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_ERROR Upon failure. The contents of value are undefined. 
.PP
OMPI_SUCCESS Upon success. value will be filled with the parameter's current value.
.RE
.PP
Note that if a string value is read in from a file then it will never be NULL. It will always have a value, even if that value is the empty string.
.PP
Strings returns in the \fIvalue\fP parameter should later be free()'ed.
.PP
The value of a specific MCA parameter can be looked up using the return value from \fBmca_base_param_register_string()\fP. 
.SS "OMPI_DECLSPEC int mca_base_param_reg_int (const \fBmca_base_component_t\fP * component, const char * param_name, const char * help_msg, bool internal, bool read_only, int default_value, int * current_value)"
.PP
Register an integer MCA parameter. 
.PP
\fBParameters:\fP
.RS 4
\fIcomponent\fP [in] Pointer to the componet for which the parameter is being registered (string), or NULL. 
.br
\fIparam_name\fP [in] The name of the parameter being registered (string). 
.br
\fIhelp_msg\fP [in] A string describing the use and valid values of the parameter (string). 
.br
\fIinternal\fP [in] Indicates whether the parameter is internal (i.e., not to be shown to users) or not (bool). 
.br
\fIread_only\fP [in] Indicates whether the parameter value can ever change (bool). 
.br
\fIdefault_value\fP [in] The value that is used for this parameter if the user does not supply one. 
.br
\fIcurrent_value\fP [out] After registering the parameter, look up its current value and return it unless current_value is NULL.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP Upon failure to register the parameter. 
.br
\fIindex\fP Index value that can be used with \fBmca_base_param_lookup_int()\fP to retrieve the value of the parameter.
.RE
.PP
This function registers an integer MCA parameter and associates it with a specific component.
.PP
If the {component} pointer is not NULL, the type name and component name are automatically prefixed to the parameter name. Otherwise, the {param_name} is used as the full parameter name.
.PP
The {help_msg} is a string of arbitrary length (verbose is good!) for explaining what the parameter is for and what its valid values are. This message is used in help messages, such as the output from the ompi_info executable.
.PP
If {internal} is set to true, this parameter is now shown by default in the output of ompi_info. That is, this parameter is considered internal to the Open MPI implementation and is not supposed to be viewed / changed by the user.
.PP
If {read_only} is true, then the registered {default_value} will be the only value ever returned when this parameter is looked up. That is, command line, environment, and file overrides will be ignored. This is useful, for example, for reporting information to the user (e.g., the version of the GM library that was linked against).
.PP
If the {current_value} is not NULL, when the registration is complete, the parameter system will look up the current value of the parameter and return it in {current_value}. 
.SS "OMPI_DECLSPEC int mca_base_param_reg_int_name (const char * type, const char * param_name, const char * help_msg, bool internal, bool read_only, int default_value, int * current_value)"
.PP
Register an integer MCA parameter that is not associated with a component. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP [in] Although this parameter is not associated with a component, it still must have a string type name that will act as a prefix (string). 
.br
\fIparam_name\fP [in] The name of the parameter being registered (string). 
.br
\fIhelp_msg\fP [in] A string describing the use and valid values of the parameter (string). 
.br
\fIinternal\fP [in] Indicates whether the parameter is internal (i.e., not to be shown to users) or not (bool). 
.br
\fIread_only\fP [in] Indicates whether the parameter value can ever change (bool). 
.br
\fIdefault_value\fP [in] The value that is used for this parameter if the user does not supply one. 
.br
\fIcurrent_value\fP [out] After registering the parameter, look up its current value and return it unless current_value is NULL.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP Upon failure to register the parameter. 
.br
\fIindex\fP Index value that can be used with \fBmca_base_param_lookup_string()\fP to retrieve the value of the parameter.
.RE
.PP
This function is identical to \fBmca_base_param_reg_int()\fP except that it registers parameters that are not associated with components. For example, it can be used to register parameters associated with a framework base or an overall layer (e.g., the MPI layer, or the MCA base system framework itself). Typical 'type' strings are:
.PP
* 'mca': for the MCA base framework itself * framework name: for any given framework * 'mpi': for parameters that apply to the overall MPI layer * 'orte': for parameters that apply to the overall ORTE layer 
.SS "OMPI_DECLSPEC int mca_base_param_reg_string (const \fBmca_base_component_t\fP * component, const char * param_name, const char * help_msg, bool internal, bool read_only, const char * default_value, char ** current_value)"
.PP
Register a string MCA parameter. 
.PP
\fBParameters:\fP
.RS 4
\fIcomponent\fP [in] Pointer to the componet for which the parameter is being registered (string), or NULL. 
.br
\fIparam_name\fP [in] The name of the parameter being registered (string). 
.br
\fIhelp_msg\fP [in] A string describing the use and valid values of the parameter (string). 
.br
\fIinternal\fP [in] Indicates whether the parameter is internal (i.e., not to be shown to users) or not (bool). 
.br
\fIread_only\fP [in] Indicates whether the parameter value can ever change (bool). 
.br
\fIdefault_value\fP [in] The value that is used for this parameter if the user does not supply one. 
.br
\fIcurrent_value\fP [out] After registering the parameter, look up its current value and return it unless current_value is NULL.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP Upon failure to register the parameter. 
.br
\fIindex\fP Index value that can be used with \fBmca_base_param_lookup_string()\fP to retrieve the value of the parameter.
.RE
.PP
Note that if a string value is read in from a file then it will never be NULL. It will always have a value, even if that value is the empty string.
.PP
This function is identical to \fBmca_base_param_reg_int()\fP except that you are registering a string parameter with an associated string default value (which is \fInot\fP allowed to be NULL). See \fBmca_base_param_reg_int()\fP for all other details. 
.SS "OMPI_DECLSPEC int mca_base_param_reg_string_name (const char * type, const char * param_name, const char * help_msg, bool internal, bool read_only, const char * default_value, char ** current_value)"
.PP
Register a string MCA parameter that is not associated with a component. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP [in] Although this parameter is not associated with a component, it still must have a string type name that will act as a prefix (string). 
.br
\fIparam_name\fP [in] The name of the parameter being registered (string). 
.br
\fIhelp_msg\fP [in] A string describing the use and valid values of the parameter (string). 
.br
\fIinternal\fP [in] Indicates whether the parameter is internal (i.e., not to be shown to users) or not (bool). 
.br
\fIread_only\fP [in] Indicates whether the parameter value can ever change (bool). 
.br
\fIdefault_value\fP [in] The value that is used for this parameter if the user does not supply one. 
.br
\fIcurrent_value\fP [out] After registering the parameter, look up its current value and return it unless current_value is NULL.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP Upon failure to register the parameter. 
.br
\fIindex\fP Index value that can be used with \fBmca_base_param_lookup_string()\fP to retrieve the value of the parameter.
.RE
.PP
Note that if a string value is read in from a file then it will never be NULL. It will always have a value, even if that value is the empty string.
.PP
This function is identical to \fBmca_base_param_reg_string()\fP except that it registers parameters that are not associated with components. For example, it can be used to register parameters associated with a framework base or an overall layer (e.g., the MPI layer, or the MCA base system framework itself). Typical 'type' strings are:
.PP
* 'mca': for the MCA base framework itself * framework name: for any given framework * 'mpi': for parameters that apply to the overall MPI layer * 'orte': for parameters that apply to the overall ORTE layer 
.SS "OMPI_DECLSPEC int mca_base_param_register_int (const char * type_name, const char * component_name, const char * param_name, const char * mca_param_name, int default_value)"
.PP
\fBDeprecated\fP
.RS 4
.RE
.PP
Register an integer MCA parameter (deprecated).
.PP
\fBParameters:\fP
.RS 4
\fItype_name\fP [in] The MCA type (string). 
.br
\fIcomponent_name\fP [in] The name of the component (string). 
.br
\fIparam_name\fP [in] The name of the parameter being registered (string). 
.br
\fImca_param_name\fP [in] Optional parameter to override the user-visible name of this parameter (string). 
.br
\fIdefault_value\fP [in] The value that is used for this parameter if the user does not supply one.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP Upon failure to register the parameter. 
.br
\fIindex\fP Index value that can be used with \fBmca_base_param_lookup_int()\fP to retrieve the value of the parameter.
.RE
.PP
This function is deprecated. Use \fBmca_base_param_reg_int()\fP instead.
.PP
This function registers an integer MCA parameter and associates it with a specific component.
.PP
The default resulting MCA parameter name is {type_name}[_{component_name}][_{param_name}].
.PP
{component_name} is only included if it is non-NULL. All components an should include their name; component frameworks should pass 'base'. It is only permissible for the MCA base itself to pass NULL for the component_name.
.PP
Likewise, {param_name} is also only included if it is non-NULL. Components and frameworks can pass NULL for this parameter if they wish.
.PP
In most cases, mca_param_name should be NULL, in which case the user-visible name of this parameter will be the default form (as described above). Only in rare cases is it necessary (or advisable) to override the default name -- its use is strongly discouraged.
.PP
It is permissable to register a (type_name, component_name, param_name) triple more than once; the same index value will be returned, but the default value will be changed to reflect the last registration. 
.SS "OMPI_DECLSPEC int mca_base_param_register_string (const char * type_name, const char * component_name, const char * param_name, const char * mca_param_name, const char * default_value)"
.PP
\fBDeprecated\fP
.RS 4
.RE
.PP
Register a string MCA parameter (deprecated).
.PP
\fBParameters:\fP
.RS 4
\fItype_name\fP [in] The MCA type (string). 
.br
\fIcomponent_name\fP [in] The name of the component (string). 
.br
\fIparam_name\fP [in] The name of the parameter being registered (string). 
.br
\fImca_param_name\fP [in] Optional parameter to override the user-visible name of this parameter (string). 
.br
\fIdefault_value\fP [in] The value that is used for this parameter if the user does not supply one.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP Upon failure to register the parameter. 
.br
\fIindex\fP Index value that can be used with \fBmca_base_param_lookup_string()\fP to retrieve the value of the parameter.
.RE
.PP
This function is deprecated. Use \fBmca_base_param_reg_string()\fP instead.
.PP
Note that if a string value is read in from a file then it will never be NULL. It will always have a value, even if that value is the empty string.
.PP
This function is identical to \fBmca_base_param_register_int()\fP except that you are registering a string parameter with an associated string default value (which is \fInot\fP allowed to be NULL). See \fBmca_base_param_register_int()\fP for all other details. 
.SS "OMPI_DECLSPEC int mca_base_param_set_int (int index, int value)"
.PP
Sets an 'override' value for an integer MCA parameter. 
.PP
\fBParameters:\fP
.RS 4
\fIindex\fP [in] Index of MCA parameter to set 
.br
\fIvalue\fP [in] The integer value to set
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP If the parameter was not found. 
.br
\fIOMPI_SUCCESS\fP Upon success.
.RE
.PP
This function sets an integer value on the MCA parmeter indicated by the index value index. This value will be used in lieu of any other value from any other MCA source (environment variable, file, etc.) until the value is unset with \fBmca_base_param_unset()\fP.
.PP
This function may be invoked multiple times; each time, the last 'set' value is replaced with the newest value. 
.SS "OMPI_DECLSPEC int mca_base_param_set_internal (int index, bool internal)"
.PP
Set the 'internal' flag on an MCA parameter to true or false. 
.PP
\fBParameters:\fP
.RS 4
\fIindex\fP [in] Index previous returned from \fBmca_base_param_register_string()\fP or \fBmca_base_param_register_int()\fP. 
.br
\fIinternal\fP [in] Boolean indicating whether the MCA parameter is internal (private) or public.
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS If it can find the parameter to reset 
.PP
OMPI_ERROR Otherwise
.RE
.PP
'Internal' MCA parameters are ones that are not intentended to be seen or modified by users or user applications. These include values that are set at run time, such as TCP ports, IP addresses, etc. By setting the 'internal' flag, internal MCA parameters are not displayed during the output of ompi_info and MPI_INIT (at least, they're not displayed by default), thus keeping them away from prying user eyes. 
.SS "OMPI_DECLSPEC int mca_base_param_set_string (int index, char * value)"
.PP
Sets an 'override' value for an string MCA parameter. 
.PP
\fBParameters:\fP
.RS 4
\fIindex\fP [in] Index of MCA parameter to set 
.br
\fIvalue\fP [in] The string value to set
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP If the parameter was not found. 
.br
\fIOMPI_SUCCESS\fP Upon success.
.RE
.PP
This function sets a string value on the MCA parmeter indicated by the index value index. This value will be used in lieu of any other value from any other MCA source (environment variable, file, etc.) until the value is unset with \fBmca_base_param_unset()\fP.
.PP
The string is copied by value; the string 'value' parameter does not become 'owned' by the parameter subsystem.
.PP
This function may be invoked multiple times; each time, the last 'set' value is replaced with the newest value (the old value is discarded). 
.SS "OMPI_DECLSPEC int mca_base_param_unset (int index)"
.PP
Unset a parameter that was previously set by \fBmca_base_param_set_int()\fP or \fBmca_base_param_set_string()\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIindex\fP [in] Index of MCA parameter to set
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP If the parameter was not found. 
.br
\fIOMPI_SUCCESS\fP Upon success.
.RE
.PP
Resets previous value that was set (if any) on the given MCA parameter. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
